"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function() {
        return PQueue;
    }
});
var _eventemitter3 = require("eventemitter3");
var _pTimeout = /*#__PURE__*/ _interopRequireWildcard(require("p-timeout"));
var _priorityQueueJs = /*#__PURE__*/ _interopRequireDefault(require("./priority-queue.js"));
function _assertThisInitialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _checkPrivateRedeclaration(obj, privateCollection) {
    if (privateCollection.has(obj)) {
        throw new TypeError("Cannot initialize the same private elements twice on an object");
    }
}
function _classApplyDescriptorGet(receiver, descriptor) {
    if (descriptor.get) {
        return descriptor.get.call(receiver);
    }
    return descriptor.value;
}
function _classApplyDescriptorSet(receiver, descriptor, value) {
    if (descriptor.set) {
        descriptor.set.call(receiver, value);
    } else {
        if (!descriptor.writable) {
            throw new TypeError("attempted to set read only private field");
        }
        descriptor.value = value;
    }
}
function _classApplyDescriptorUpdate(receiver, descriptor) {
    if (descriptor.set) {
        if (!("__destrWrapper" in descriptor)) {
            descriptor.__destrWrapper = {
                set value (v){
                    descriptor.set.call(receiver, v);
                },
                get value () {
                    return descriptor.get.call(receiver);
                }
            };
        }
        return descriptor.__destrWrapper;
    } else {
        if (!descriptor.writable) {
            throw new TypeError("attempted to set read only private field");
        }
        return descriptor;
    }
}
function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _classExtractFieldDescriptor(receiver, privateMap, action) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to " + action + " private field on non-instance");
    }
    return privateMap.get(receiver);
}
function _classPrivateFieldGet(receiver, privateMap) {
    var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get");
    return _classApplyDescriptorGet(receiver, descriptor);
}
function _classPrivateFieldInit(obj, privateMap, value) {
    _checkPrivateRedeclaration(obj, privateMap);
    privateMap.set(obj, value);
}
function _classPrivateFieldSet(receiver, privateMap, value) {
    var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set");
    _classApplyDescriptorSet(receiver, descriptor, value);
    return value;
}
function _classPrivateFieldUpdate(receiver, privateMap) {
    var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "update");
    return _classApplyDescriptorUpdate(receiver, descriptor);
}
function _classPrivateMethodGet(receiver, privateSet, fn) {
    if (!privateSet.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return fn;
}
function _classPrivateMethodInit(obj, privateSet) {
    _checkPrivateRedeclaration(obj, privateSet);
    privateSet.add(obj);
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
}
function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
}
function _instanceof(left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
        return !!right[Symbol.hasInstance](left);
    } else {
        return left instanceof right;
    }
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assertThisInitialized(self);
}
function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };
    return _setPrototypeOf(o, p);
}
var _typeof = function(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
};
function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
        return true;
    } catch (e) {
        return false;
    }
}
function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();
    return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result;
        if (hasNativeReflectConstruct) {
            var NewTarget = _getPrototypeOf(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget);
        } else {
            result = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result);
    };
}
var __generator = (void 0) && (void 0).__generator || function(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v1) {
            return step([
                n,
                v1
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
};
var _carryoverConcurrencyCount = /*#__PURE__*/ new WeakMap(), _isIntervalIgnored = /*#__PURE__*/ new WeakMap(), _intervalCount = /*#__PURE__*/ new WeakMap(), _intervalCap = /*#__PURE__*/ new WeakMap(), _interval = /*#__PURE__*/ new WeakMap(), _intervalEnd = /*#__PURE__*/ new WeakMap(), _intervalId = /*#__PURE__*/ new WeakMap(), _timeoutId = /*#__PURE__*/ new WeakMap(), _queue = /*#__PURE__*/ new WeakMap(), _queueClass = /*#__PURE__*/ new WeakMap(), _pending = /*#__PURE__*/ new WeakMap(), // The `!` is needed because of https://github.com/microsoft/TypeScript/issues/32194
_concurrency = /*#__PURE__*/ new WeakMap(), _isPaused = /*#__PURE__*/ new WeakMap(), _throwOnTimeout = /*#__PURE__*/ new WeakMap(), _doesIntervalAllowAnother = /*#__PURE__*/ new WeakMap(), _doesConcurrentAllowAnother = /*#__PURE__*/ new WeakMap(), _next = /*#__PURE__*/ new WeakSet(), _onResumeInterval = /*#__PURE__*/ new WeakSet(), _isIntervalPaused = /*#__PURE__*/ new WeakMap(), _tryToStartAnother = /*#__PURE__*/ new WeakSet(), _initializeIntervalIfNeeded = /*#__PURE__*/ new WeakSet(), _onInterval = /*#__PURE__*/ new WeakSet(), /**
    Executes all queued functions until it reaches the limit.
    */ _processQueue = /*#__PURE__*/ new WeakSet(), _throwOnAbort = /*#__PURE__*/ new WeakSet(), _onEvent = /*#__PURE__*/ new WeakSet();
var PQueue = /*#__PURE__*/ function(EventEmitter) {
    "use strict";
    _inherits(PQueue, EventEmitter);
    var _super = _createSuper(PQueue);
    function PQueue(options) {
        _classCallCheck(this, PQueue);
        var _this;
        _this = _super.call(this);
        _classPrivateFieldInit(_assertThisInitialized(_this), _doesIntervalAllowAnother, {
            get: get_doesIntervalAllowAnother,
            set: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _doesConcurrentAllowAnother, {
            get: get_doesConcurrentAllowAnother,
            set: void 0
        });
        _classPrivateMethodInit(_assertThisInitialized(_this), _next);
        _classPrivateMethodInit(_assertThisInitialized(_this), _onResumeInterval);
        _classPrivateFieldInit(_assertThisInitialized(_this), _isIntervalPaused, {
            get: get_isIntervalPaused,
            set: void 0
        });
        _classPrivateMethodInit(_assertThisInitialized(_this), _tryToStartAnother);
        _classPrivateMethodInit(_assertThisInitialized(_this), _initializeIntervalIfNeeded);
        _classPrivateMethodInit(_assertThisInitialized(_this), _onInterval);
        _classPrivateMethodInit(_assertThisInitialized(_this), _processQueue);
        _classPrivateMethodInit(_assertThisInitialized(_this), _throwOnAbort);
        _classPrivateMethodInit(_assertThisInitialized(_this), _onEvent);
        _classPrivateFieldInit(_assertThisInitialized(_this), _carryoverConcurrencyCount, {
            writable: true,
            value: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _isIntervalIgnored, {
            writable: true,
            value: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _intervalCount, {
            writable: true,
            value: 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _intervalCap, {
            writable: true,
            value: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _interval, {
            writable: true,
            value: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _intervalEnd, {
            writable: true,
            value: 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _intervalId, {
            writable: true,
            value: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _timeoutId, {
            writable: true,
            value: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _queue, {
            writable: true,
            value: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _queueClass, {
            writable: true,
            value: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _pending, {
            writable: true,
            value: 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _concurrency, {
            writable: true,
            value: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _isPaused, {
            writable: true,
            value: void 0
        });
        _classPrivateFieldInit(_assertThisInitialized(_this), _throwOnTimeout, {
            writable: true,
            value: void 0
        });
        /**
    Per-operation timeout in milliseconds. Operations fulfill once `timeout` elapses if they haven't already.

    Applies to each future operation.
    */ _defineProperty(_assertThisInitialized(_this), "timeout", void 0);
        // eslint-disable-next-line @typescript-eslint/consistent-type-assertions
        options = _objectSpread({
            carryoverConcurrencyCount: false,
            intervalCap: Number.POSITIVE_INFINITY,
            interval: 0,
            concurrency: Number.POSITIVE_INFINITY,
            autoStart: true,
            queueClass: _priorityQueueJs.default
        }, options);
        if (!(typeof options.intervalCap === "number" && options.intervalCap >= 1)) {
            var ref;
            var ref1;
            throw new TypeError("Expected `intervalCap` to be a number from 1 and up, got `".concat((ref1 = (ref = options.intervalCap) === null || ref === void 0 ? void 0 : ref.toString()) !== null && ref1 !== void 0 ? ref1 : "", "` (").concat(_typeof(options.intervalCap), ")"));
        }
        if (options.interval === undefined || !(Number.isFinite(options.interval) && options.interval >= 0)) {
            var ref2;
            var ref3;
            throw new TypeError("Expected `interval` to be a finite number >= 0, got `".concat((ref3 = (ref2 = options.interval) === null || ref2 === void 0 ? void 0 : ref2.toString()) !== null && ref3 !== void 0 ? ref3 : "", "` (").concat(_typeof(options.interval), ")"));
        }
        _classPrivateFieldSet(_assertThisInitialized(_this), _carryoverConcurrencyCount, options.carryoverConcurrencyCount);
        _classPrivateFieldSet(_assertThisInitialized(_this), _isIntervalIgnored, options.intervalCap === Number.POSITIVE_INFINITY || options.interval === 0);
        _classPrivateFieldSet(_assertThisInitialized(_this), _intervalCap, options.intervalCap);
        _classPrivateFieldSet(_assertThisInitialized(_this), _interval, options.interval);
        _classPrivateFieldSet(_assertThisInitialized(_this), _queue, new options.queueClass());
        _classPrivateFieldSet(_assertThisInitialized(_this), _queueClass, options.queueClass);
        _this.concurrency = options.concurrency;
        _this.timeout = options.timeout;
        _classPrivateFieldSet(_assertThisInitialized(_this), _throwOnTimeout, options.throwOnTimeout === true);
        _classPrivateFieldSet(_assertThisInitialized(_this), _isPaused, options.autoStart === false);
        return _this;
    }
    _createClass(PQueue, [
        {
            key: "concurrency",
            get: function get() {
                return _classPrivateFieldGet(this, _concurrency);
            },
            set: function set(newConcurrency) {
                if (!(typeof newConcurrency === "number" && newConcurrency >= 1)) {
                    throw new TypeError("Expected `concurrency` to be a number from 1 and up, got `".concat(newConcurrency, "` (").concat(typeof newConcurrency === "undefined" ? "undefined" : _typeof(newConcurrency), ")"));
                }
                _classPrivateFieldSet(this, _concurrency, newConcurrency);
                _classPrivateMethodGet(this, _processQueue, processQueue).call(this);
            }
        },
        {
            key: "add",
            value: function add(function_) {
                var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
                var _this = this;
                return _asyncToGenerator(function() {
                    return __generator(this, function(_state) {
                        options = _objectSpread({
                            timeout: _this.timeout,
                            throwOnTimeout: _classPrivateFieldGet(_this, _throwOnTimeout)
                        }, options);
                        return [
                            2,
                            new Promise(function(resolve, reject) {
                                _classPrivateFieldGet(_this, _queue).enqueue(/*#__PURE__*/ _asyncToGenerator(function() {
                                    var ref, operation, result, error;
                                    return __generator(this, function(_state) {
                                        switch(_state.label){
                                            case 0:
                                                _classPrivateFieldUpdate(_this, _pending).value++;
                                                _classPrivateFieldUpdate(_this, _intervalCount).value++;
                                                _state.label = 1;
                                            case 1:
                                                _state.trys.push([
                                                    1,
                                                    3,
                                                    4,
                                                    5
                                                ]);
                                                (ref = options.signal) === null || ref === void 0 ? void 0 : ref.throwIfAborted();
                                                operation = function_({
                                                    signal: options.signal
                                                });
                                                if (options.timeout) {
                                                    operation = (0, _pTimeout.default)(Promise.resolve(operation), {
                                                        milliseconds: options.timeout
                                                    });
                                                }
                                                if (options.signal) {
                                                    operation = Promise.race([
                                                        operation,
                                                        _classPrivateMethodGet(_this, _throwOnAbort, throwOnAbort).call(_this, options.signal)
                                                    ]);
                                                }
                                                return [
                                                    4,
                                                    operation
                                                ];
                                            case 2:
                                                result = _state.sent();
                                                resolve(result);
                                                _this.emit("completed", result);
                                                return [
                                                    3,
                                                    5
                                                ];
                                            case 3:
                                                error = _state.sent();
                                                if (_instanceof(error, _pTimeout.TimeoutError) && !options.throwOnTimeout) {
                                                    resolve();
                                                    return [
                                                        2
                                                    ];
                                                }
                                                reject(error);
                                                _this.emit("error", error);
                                                return [
                                                    3,
                                                    5
                                                ];
                                            case 4:
                                                _classPrivateMethodGet(_this, _next, next).call(_this);
                                                return [
                                                    7
                                                ];
                                            case 5:
                                                return [
                                                    2
                                                ];
                                        }
                                    });
                                }), options);
                                _this.emit("add");
                                _classPrivateMethodGet(_this, _tryToStartAnother, tryToStartAnother).call(_this);
                            })
                        ];
                    });
                })();
            }
        },
        {
            key: "addAll",
            value: function addAll(functions, options) {
                var _this = this;
                return _asyncToGenerator(function() {
                    return __generator(this, function(_state) {
                        return [
                            2,
                            Promise.all(functions.map(function() {
                                var _ref = _asyncToGenerator(function(function_) {
                                    return __generator(this, function(_state) {
                                        return [
                                            2,
                                            _this.add(function_, options)
                                        ];
                                    });
                                });
                                return function(function_) {
                                    return _ref.apply(this, arguments);
                                };
                            }()))
                        ];
                    });
                })();
            }
        },
        {
            /**
    Start (or resume) executing enqueued tasks within concurrency limit. No need to call this if queue is not paused (via `options.autoStart = false` or by `.pause()` method.)
    */ key: "start",
            value: function start() {
                if (!_classPrivateFieldGet(this, _isPaused)) {
                    return this;
                }
                _classPrivateFieldSet(this, _isPaused, false);
                _classPrivateMethodGet(this, _processQueue, processQueue).call(this);
                return this;
            }
        },
        {
            /**
    Put queue execution on hold.
    */ key: "pause",
            value: function pause() {
                _classPrivateFieldSet(this, _isPaused, true);
            }
        },
        {
            /**
    Clear the queue.
    */ key: "clear",
            value: function clear() {
                _classPrivateFieldSet(this, _queue, new (_classPrivateFieldGet(this, _queueClass))());
            }
        },
        {
            key: "onEmpty",
            value: /**
    Can be called multiple times. Useful if you for example add additional items at a later time.

    @returns A promise that settles when the queue becomes empty.
    */ function onEmpty() {
                var _this = this;
                return _asyncToGenerator(function() {
                    return __generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                // Instantly resolve if the queue is empty
                                if (_classPrivateFieldGet(_this, _queue).size === 0) {
                                    return [
                                        2
                                    ];
                                }
                                return [
                                    4,
                                    _classPrivateMethodGet(_this, _onEvent, onEvent).call(_this, "empty")
                                ];
                            case 1:
                                _state.sent();
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "onSizeLessThan",
            value: /**
    @returns A promise that settles when the queue size is less than the given limit: `queue.size < limit`.

    If you want to avoid having the queue grow beyond a certain size you can `await queue.onSizeLessThan()` before adding a new item.

    Note that this only limits the number of items waiting to start. There could still be up to `concurrency` jobs already running that this call does not include in its calculation.
    */ function onSizeLessThan(limit) {
                var _this = this;
                return _asyncToGenerator(function() {
                    return __generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                // Instantly resolve if the queue is empty.
                                if (_classPrivateFieldGet(_this, _queue).size < limit) {
                                    return [
                                        2
                                    ];
                                }
                                return [
                                    4,
                                    _classPrivateMethodGet(_this, _onEvent, onEvent).call(_this, "next", function() {
                                        return _classPrivateFieldGet(_this, _queue).size < limit;
                                    })
                                ];
                            case 1:
                                _state.sent();
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "onIdle",
            value: /**
    The difference with `.onEmpty` is that `.onIdle` guarantees that all work from the queue has finished. `.onEmpty` merely signals that the queue is empty, but it could mean that some promises haven't completed yet.

    @returns A promise that settles when the queue becomes empty, and all promises have completed; `queue.size === 0 && queue.pending === 0`.
    */ function onIdle() {
                var _this = this;
                return _asyncToGenerator(function() {
                    return __generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                // Instantly resolve if none pending and if nothing else is queued
                                if (_classPrivateFieldGet(_this, _pending) === 0 && _classPrivateFieldGet(_this, _queue).size === 0) {
                                    return [
                                        2
                                    ];
                                }
                                return [
                                    4,
                                    _classPrivateMethodGet(_this, _onEvent, onEvent).call(_this, "idle")
                                ];
                            case 1:
                                _state.sent();
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "size",
            get: /**
    Size of the queue, the number of queued items waiting to run.
    */ function get() {
                return _classPrivateFieldGet(this, _queue).size;
            }
        },
        {
            /**
    Size of the queue, filtered by the given options.

    For example, this can be used to find the number of items remaining in the queue with a specific priority level.
    */ key: "sizeBy",
            value: function sizeBy(options) {
                // eslint-disable-next-line unicorn/no-array-callback-reference
                return _classPrivateFieldGet(this, _queue).filter(options).length;
            }
        },
        {
            key: "pending",
            get: /**
    Number of running items (no longer in the queue).
    */ function get() {
                return _classPrivateFieldGet(this, _pending);
            }
        },
        {
            key: "isPaused",
            get: /**
    Whether the queue is currently paused.
    */ function get() {
                return _classPrivateFieldGet(this, _isPaused);
            }
        }
    ]);
    return PQueue;
}(_eventemitter3.EventEmitter);
function get_doesIntervalAllowAnother() {
    return _classPrivateFieldGet(this, _isIntervalIgnored) || _classPrivateFieldGet(this, _intervalCount) < _classPrivateFieldGet(this, _intervalCap);
}
function get_doesConcurrentAllowAnother() {
    return _classPrivateFieldGet(this, _pending) < _classPrivateFieldGet(this, _concurrency);
}
function next() {
    _classPrivateFieldUpdate(this, _pending).value--;
    _classPrivateMethodGet(this, _tryToStartAnother, tryToStartAnother).call(this);
    this.emit("next");
}
function onResumeInterval() {
    _classPrivateMethodGet(this, _onInterval, onInterval).call(this);
    _classPrivateMethodGet(this, _initializeIntervalIfNeeded, initializeIntervalIfNeeded).call(this);
    _classPrivateFieldSet(this, _timeoutId, undefined);
}
function get_isIntervalPaused() {
    var _this = this;
    var now = Date.now();
    if (_classPrivateFieldGet(this, _intervalId) === undefined) {
        var delay = _classPrivateFieldGet(this, _intervalEnd) - now;
        if (delay < 0) {
            _classPrivateFieldSet(this, _intervalCount, _classPrivateFieldGet(this, _carryoverConcurrencyCount) ? _classPrivateFieldGet(this, _pending) : 0);
        } else {
            // Act as the interval is pending
            if (_classPrivateFieldGet(this, _timeoutId) === undefined) {
                _classPrivateFieldSet(this, _timeoutId, setTimeout(function() {
                    _classPrivateMethodGet(_this, _onResumeInterval, onResumeInterval).call(_this);
                }, delay));
            }
            return true;
        }
    }
    return false;
}
function tryToStartAnother() {
    if (_classPrivateFieldGet(this, _queue).size === 0) {
        // We can clear the interval ("pause")
        // Because we can redo it later ("resume")
        if (_classPrivateFieldGet(this, _intervalId)) {
            clearInterval(_classPrivateFieldGet(this, _intervalId));
        }
        _classPrivateFieldSet(this, _intervalId, undefined);
        this.emit("empty");
        if (_classPrivateFieldGet(this, _pending) === 0) {
            this.emit("idle");
        }
        return false;
    }
    if (!_classPrivateFieldGet(this, _isPaused)) {
        var canInitializeInterval = !_classPrivateFieldGet(this, _isIntervalPaused);
        if (_classPrivateFieldGet(this, _doesIntervalAllowAnother) && _classPrivateFieldGet(this, _doesConcurrentAllowAnother)) {
            var job = _classPrivateFieldGet(this, _queue).dequeue();
            if (!job) {
                return false;
            }
            this.emit("active");
            job();
            if (canInitializeInterval) {
                _classPrivateMethodGet(this, _initializeIntervalIfNeeded, initializeIntervalIfNeeded).call(this);
            }
            return true;
        }
    }
    return false;
}
function initializeIntervalIfNeeded() {
    var _this = this;
    if (_classPrivateFieldGet(this, _isIntervalIgnored) || _classPrivateFieldGet(this, _intervalId) !== undefined) {
        return;
    }
    _classPrivateFieldSet(this, _intervalId, setInterval(function() {
        _classPrivateMethodGet(_this, _onInterval, onInterval).call(_this);
    }, _classPrivateFieldGet(this, _interval)));
    _classPrivateFieldSet(this, _intervalEnd, Date.now() + _classPrivateFieldGet(this, _interval));
}
function onInterval() {
    if (_classPrivateFieldGet(this, _intervalCount) === 0 && _classPrivateFieldGet(this, _pending) === 0 && _classPrivateFieldGet(this, _intervalId)) {
        clearInterval(_classPrivateFieldGet(this, _intervalId));
        _classPrivateFieldSet(this, _intervalId, undefined);
    }
    _classPrivateFieldSet(this, _intervalCount, _classPrivateFieldGet(this, _carryoverConcurrencyCount) ? _classPrivateFieldGet(this, _pending) : 0);
    _classPrivateMethodGet(this, _processQueue, processQueue).call(this);
}
function processQueue() {
    // eslint-disable-next-line no-empty
    while(_classPrivateMethodGet(this, _tryToStartAnother, tryToStartAnother).call(this)){}
}
function throwOnAbort(signal) {
    return _throwOnAbort1.apply(this, arguments);
}
function _throwOnAbort1() {
    _throwOnAbort1 = _asyncToGenerator(function(signal) {
        return __generator(this, function(_state) {
            return [
                2,
                new Promise(function(_resolve, reject) {
                    signal.addEventListener("abort", function() {
                        reject(signal.reason);
                    }, {
                        once: true
                    });
                })
            ];
        });
    });
    return _throwOnAbort1.apply(this, arguments);
}
function onEvent(event, filter) {
    return _onEvent1.apply(this, arguments);
}
function _onEvent1() {
    _onEvent1 = _asyncToGenerator(function(event, filter) {
        var _this;
        return __generator(this, function(_state) {
            _this = this;
            return [
                2,
                new Promise(function(resolve) {
                    var listener = function() {
                        if (filter && !filter()) {
                            return;
                        }
                        _this.off(event, listener);
                        resolve();
                    };
                    _this.on(event, listener);
                })
            ];
        });
    });
    return _onEvent1.apply(this, arguments);
}
