"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function() {
        return PriorityQueue;
    }
});
var _lowerBoundJs = /*#__PURE__*/ _interopRequireDefault(require("./lower-bound.js"));
function _checkPrivateRedeclaration(obj, privateCollection) {
    if (privateCollection.has(obj)) {
        throw new TypeError("Cannot initialize the same private elements twice on an object");
    }
}
function _classApplyDescriptorGet(receiver, descriptor) {
    if (descriptor.get) {
        return descriptor.get.call(receiver);
    }
    return descriptor.value;
}
function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _classExtractFieldDescriptor(receiver, privateMap, action) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to " + action + " private field on non-instance");
    }
    return privateMap.get(receiver);
}
function _classPrivateFieldGet(receiver, privateMap) {
    var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get");
    return _classApplyDescriptorGet(receiver, descriptor);
}
function _classPrivateFieldInit(obj, privateMap, value) {
    _checkPrivateRedeclaration(obj, privateMap);
    privateMap.set(obj, value);
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var _queue = /*#__PURE__*/ new WeakMap();
var PriorityQueue = /*#__PURE__*/ function() {
    "use strict";
    function PriorityQueue() {
        _classCallCheck(this, PriorityQueue);
        _classPrivateFieldInit(this, _queue, {
            writable: true,
            value: []
        });
    }
    _createClass(PriorityQueue, [
        {
            key: "enqueue",
            value: function enqueue(run, options) {
                options = _objectSpread({
                    priority: 0
                }, options);
                var element = {
                    priority: options.priority,
                    run: run
                };
                if (this.size && _classPrivateFieldGet(this, _queue)[this.size - 1].priority >= options.priority) {
                    _classPrivateFieldGet(this, _queue).push(element);
                    return;
                }
                var index = (0, _lowerBoundJs.default)(_classPrivateFieldGet(this, _queue), element, function(a, b) {
                    return b.priority - a.priority;
                });
                _classPrivateFieldGet(this, _queue).splice(index, 0, element);
            }
        },
        {
            key: "dequeue",
            value: function dequeue() {
                var item = _classPrivateFieldGet(this, _queue).shift();
                return item === null || item === void 0 ? void 0 : item.run;
            }
        },
        {
            key: "filter",
            value: function filter(options) {
                return _classPrivateFieldGet(this, _queue).filter(function(element) {
                    return element.priority === options.priority;
                }).map(function(element) {
                    return element.run;
                });
            }
        },
        {
            key: "size",
            get: function get() {
                return _classPrivateFieldGet(this, _queue).length;
            }
        }
    ]);
    return PriorityQueue;
}();
